import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Random;

/**
  *
  * Klasse fr einen intelligenten Computerspieler
  *
  * @version 1.0 vom 10.08.2008
  * @author Daniel Garmann
  */

public class ComputerSpieler extends Spieler {


  private int suchtiefe;
  private Zug zug;
  private JFrame owner;


  public ComputerSpieler(JFrame owner, int maximaleSuchtiefe)
  {
    this.owner = owner;
    this.suchtiefe = maximaleSuchtiefe;
  }
  
  private int bewertungsfunktion(Position position)
  {
    int[][] reihenanzahl = position.reihenanzahl();

    return reihenanzahl[  position.amZug()][4]*  1000  +
           reihenanzahl[1-position.amZug()][4]*(-5000) +
           reihenanzahl[  position.amZug()][3]*   100  +
           reihenanzahl[1-position.amZug()][3]*( -500) +
           reihenanzahl[  position.amZug()][2]*    10  +
           reihenanzahl[1-position.amZug()][2]*(  -50) +
           reihenanzahl[  position.amZug()][1]*     1  +
           reihenanzahl[1-position.amZug()][1]*(   -5)  ;
  }


  private int negamax(Position position, int tiefe)
  {
    if (position.spielendeErreicht() || (tiefe <= 0))
      return bewertungsfunktion(position);
    else {
      int wert = -Integer.MAX_VALUE;
      for (int probezugx = 0; probezugx < 4; probezugx++) {
        for (int probezugy = 0; probezugy < 4; probezugy++) {
          Zug probezug = new Zug(probezugx, probezugy);
          if (position.zulaessig(probezug)) {
            position.zugAusfuehren(probezug);
            int folgewert = -negamax(position, tiefe - 1);
            position.zugZueruecknehmen(probezug);
            if (folgewert > wert) {
              wert = folgewert;
              if (tiefe == suchtiefe)
                zug = probezug;
            }
          }

        }
      }
      return wert;
    }
  }

  private int alphabeta(Position position, int tiefe, int alpha, int beta)
  {
    if (position.spielendeErreicht() || (tiefe <= 0))
      return bewertungsfunktion(position);
    else {
      for (int probezugx = 0; probezugx < 4; probezugx++) {
        for (int probezugy = 0; probezugy < 4; probezugy++) {
          Zug probezug = new Zug(probezugx, probezugy);
          if (position.zulaessig(probezug)) {
            position.zugAusfuehren(probezug);
            int folgewert = -alphabeta(position, tiefe - 1,-beta,-alpha);
            position.zugZueruecknehmen(probezug);
            if (folgewert >= beta) {
              return beta;
            }
            if (folgewert > alpha) {
              alpha = folgewert;
              if (tiefe == suchtiefe)
                zug = probezug;
            }
          }

        }
      }
      return alpha;
    }
  }



  public Zug spielzugMachen(Position position)
  {

    if (suchtiefe > 0) {
//      negamax(position,suchtiefe);
      alphabeta(position,suchtiefe,-Integer.MAX_VALUE, Integer.MAX_VALUE);
    } else {
      do
        zug = new Zug((int)(Math.random()*4),(int)(Math.random()*4));
      while (!position.zulaessig(zug));
    }
    return zug;
  }

}
