import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  *
  * Simulation eines 3d-Viergewinnt-Spiels
  *
  * @version 1.0 vom 17.11.2008
  * @author Daniel Garmann
  */

public class Gui extends JFrame implements Runnable {
  // Anfang Attribute
  private Spiel spiel;
  private JButton jButton1 = new JButton();
  private Thread spielThread;

  public boolean menschspielerDarfSetzen = false;
  public Zug menschspielerZug;
  // Ende Attribute

  public Gui(String title) {
    // Frame-Initialisierung
    super (title);
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    int frameWidth = 592;
    int frameHeight = 395;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    jButton1.setBounds(8, 8, 129, 49);
    jButton1.setText("Start");
    jButton1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton1_ActionPerformed(evt);
      }
    });
    cp.add(jButton1);
    
    JButton b;
    for (int px = 0; px < 4; px++) {
      for (int py = 0; py < 4; py++) {
         b = new JButton();
         b.setBounds(50+px*80+py*20,220-py*20,20,20);
         b.setText(""+px+"|"+py);
         b.addActionListener(new ActionListener() {
           public void actionPerformed(ActionEvent evt) {
             b_ActionPerformed(evt);
           }
         });
         cp.add(b);
      }
    }


    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden


  public void run() {
    spiel = new Spiel(this,0);
    spiel.starten();
  }
  
  
  public void jButton1_ActionPerformed(ActionEvent evt) {
    jButton1.setVisible(false);
    menschspielerDarfSetzen = false;

    spielThread = new Thread(this);
    spielThread.start();
  }

  public void b_ActionPerformed(ActionEvent evt) {
    // TODO hier Quelltext einfgen

    if (menschspielerDarfSetzen) {
      int x = Integer.parseInt(""+((JButton)evt.getSource()).getText().charAt(0));
      int y = Integer.parseInt(""+((JButton)evt.getSource()).getText().charAt(2));
      menschspielerZug = new Zug(x,y);

      menschspielerDarfSetzen = false;
    }

  }
  
  public void reset() {
    jButton1.setVisible(true);
    
  }

  // Ende Methoden

  public static void main(String[] args) {
    new Gui("Gui");
  }
}
